/*
                       COMmunication port MANIPulator
                     =================================
  
  Le 11/01/2002 par Thibaut Barthlemy
  
  Pour toute question ou remarque, n'hsitez pas -> barthib@hotmail.com
  
  Si vous programmiez un utilitaire de ce genre, aussi modeste soit-il,
  vous y passeriez un certain temps et quelques neurones...
  Ainsi, vous comprenez que si vous souhaitez reprendre une partie de cette
  source, je vous remercierais simplement de me le signaler, pour que j'ai
  conscience que mon travail n'a pas t inutile.
  
  Amusez-vous bien ;)
  
  Thibaut.
*/

#define USE_TI89              // Produce .89z File
#define USE_TI92PLUS          // Produce .9xz File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#include <tigcclib.h>         // Include All Header Files



short readport();
short writeport(char *sequence, short delay);



void _main(void)
{
  ESI ParamsP= top_estack;
  char *mode;
  short i;
  
  if (GetArgType(ParamsP) != STR_TAG)
  {
    ST_helpMsg("The 1st argument must be a string");
    return;
  }
  
  mode= GetStrnArg(ParamsP);
  if (*mode == 'r')
  {
    char *Resultat;
    short Handle;
    
    i= readport();
    
    Handle= HeapAlloc(10);
    Resultat= HeapDeref(Handle);
    DerefSym(SymAdd("\0cm"+3))->handle= Handle;
    *Resultat++= 0x00;
    *Resultat++= 0x08;
    *Resultat++= 0xE5;
    *Resultat++= i>>8; // BLANC
    *Resultat++= 0x01;
    *Resultat++= 0x1F;
    *Resultat++= i;    // ROUGE
    *Resultat++= 0x01;
    *Resultat++= 0x1F;
    *Resultat  = 0xD9;
  }
  else if (*mode == 'w')
  {
    if (GetArgType(ParamsP) != STR_TAG)
    {
      ST_helpMsg("The 2nd argument must be a string");
      return;
    }
    mode= GetStrnArg(ParamsP);
    
    if (GetArgType(ParamsP) != POSINT_TAG)
    {
      ST_helpMsg("The 3rd argument must specify the delay");
      return;
    }
    
    if ((i= GetIntArg(ParamsP)) > 6553)
    {
      ST_helpMsg("The delay can't exceed 0.6553 seconds");
      return;
    }
    
    i= writeport(mode, i);
    if (i)
    {
      char Message[48];
      
      sprintf(Message, "Unknow state at the %uth sequence char", i);
      ST_helpMsg(Message);
    }
  }
  else
  {
    ST_helpMsg("The 1st argument must be \"r\" or \"w\"");
    return;
  }
}
